﻿using Infragistics.Controls.Maps;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace XamMapBingREST
{
    public partial class MainPage : UserControl
    {
        const string key = "your_key_here";
        public MainPage()
        {
            InitializeComponent();
            InitMapCoordinates();
        }

        private void igMap_Loaded(object sender, RoutedEventArgs e)
        {
            BingMapsConnector connector = new BingMapsConnector();
            connector.ImageryInitialized += Connector_ImageryInitialized;
            connector.ImageryStyle = BingMapsImageryStyle.Aerial;
            connector.ApiKey = key;

            try
            {
                connector.Initialize();
            }
            catch (Exception ex)
            {
                MessageBox.Show("EXCEPTION!!");
            }
        }

        private void Connector_ImageryInitialized(object sender, EventArgs e)
        {
            Dispatcher.BeginInvoke(new Action(() =>
            {
                UpdateBingMaps(sender);
            }));
        }

        private void UpdateBingMaps(object sender)
        {
            var connector = (BingMapsConnector)sender;
            this.igMap.MapTileSource = new BingMapsTileSource() { TilePath = connector.TilePath, SubDomains = connector.SubDomains };
        }

        private void InitMapCoordinates()
        {
            // define world dimensions 
            Point worldTopLeft = new Point(-180, 90);
            Point worldBottomRight = new Point(180, -90);

            // Convert Geodetic to Cartesian coordinates
            Point winTopLeft = this.igMap.MapProjection.ProjectToMap(worldTopLeft);
            Point winBottomRight = this.igMap.MapProjection.ProjectToMap(worldBottomRight);
            // Create Rect structure the map control's WindowRect and WorldRect
            Rect winRect = new Rect()
            {
                X = Math.Min(winTopLeft.X, winBottomRight.X),
                Y = Math.Min(winTopLeft.Y, winBottomRight.Y),
                Width = Math.Abs(winTopLeft.X - winBottomRight.X),
                Height = Math.Abs(winTopLeft.Y - winBottomRight.Y)
            };
            this.igMap.IsAutoWorldRect = false;
            this.igMap.WindowZoomMaximum = 80;

            // Change the map control's WindowRect and WorldRect
            this.igMap.WindowRect = this.igMap.WorldRect = winRect;
        }

    }
}
